=== plugins/dockers/CMakeLists.txt ===
add_subdirectory(defaultdockers)
add_subdirectory(smallcolorselector)
add_subdirectory(specificcolorselector)
add_subdirectory(digitalmixer)
add_subdirectory(advancedcolorselector)
add_subdirectory(presetdocker)
add_subdirectory(historydocker)
add_subdirectory(channeldocker)
add_subdirectory(artisticcolorselector)
add_subdirectory(tasksetdocker)
add_subdirectory(compositiondocker)
add_subdirectory(patterndocker)
add_subdirectory(griddocker)
add_subdirectory(arrangedocker)
if(HAVE_OCIO)
    add_subdirectory(lut)
endif()
add_subdirectory(overview)
add_subdirectory(palettedocker)
add_subdirectory(colorslider)
add_subdirectory(animation)
add_subdirectory(presethistory)
add_subdirectory(svgcollectiondocker)
add_subdirectory(histogram)
if(HAVE_QT_QUICK)
    add_subdirectory(touchdocker)
    option(ENABLE_CPU_THROTTLE "Build the CPU Throttle Docker" OFF)
    if (ENABLE_CPU_THROTTLE)
        add_subdirectory(throttle)
    endif()
endif()
