=== plugins/filters/CMakeLists.txt ===
add_subdirectory( tests )
add_subdirectory( blur )
add_subdirectory( colors )
add_subdirectory( colorsfilters )
add_subdirectory( convolutionfilters )
add_subdirectory( embossfilter )
add_subdirectory( example )
add_subdirectory( fastcolortransfer )
add_subdirectory( imageenhancement )
add_subdirectory( noisefilter )
add_subdirectory( oilpaintfilter )
add_subdirectory( pixelizefilter )
add_subdirectory( raindropsfilter )
add_subdirectory( randompickfilter )
add_subdirectory( roundcorners )
add_subdirectory( smalltilesfilter )
add_subdirectory( unsharp )
add_subdirectory( wavefilter )
add_subdirectory( levelfilter )
add_subdirectory( dodgeburn )
add_subdirectory( phongbumpmap )
add_subdirectory( posterize )
add_subdirectory( indexcolors )
add_subdirectory( normalize )
add_subdirectory( gradientmap )
add_subdirectory( threshold )
add_subdirectory( halftone )
add_subdirectory( edgedetection )
add_subdirectory( convertheightnormalmap )
add_subdirectory( asccdl )
