=== plugins/flake/CMakeLists.txt ===
add_subdirectory( imageshape )
add_subdirectory( artistictextshape )
add_subdirectory( pathshapes )
add_subdirectory( textshape )
