=== debian/changelog ===
krita (1:4.0.1+dfsg-0ubuntu1) bionic; urgency=medium

  * New upstream bugfix release (4.0.1)

 -- Rik Mills <rikmills@kubuntu.org>  Wed, 11 Apr 2018 08:11:54 +0100

krita (1:4.0.0+dfsg-0ubuntu1) bionic; urgency=medium

  * New upstream release (4.0.0) (LP: #1760347)
  * Sync debian work in progress changes
  * Add additional runtime python and QtMultimedia deps, as requested by
    Krita developers

 -- Rik Mills <rikmills@kubuntu.org>  Sat, 07 Apr 2018 12:29:08 +0100

krita (1:4.0.0+dfsg-0r1) UNRELEASED; urgency=medium

  [ Pino Toscano ]
  * New upstream release.
  * Switch Vcs-* fields to salsa.debian.org.
  * Add build dependencies for new features: libgif-dev, pyqt5-dev,
    python3-dev, python3-pyqt5, python3-sip-dev, and qtdeclarative5-dev.
  * Update install files.
  * Bump the debhelper compatibility to 11:
    - bump the debhelper build dependency to 11~
    - bump compat to 11
    - remove --parallel for dh, as now done by default
  * Switch from dh_install to dh_missing for --list-missing.

 -- Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>  Sat, 24 Mar 2018 07:32:57 +0100

krita (1:3.3.3+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Use https in the watch file.
  * Update copyright.
  * Bump Standards-Version to 4.1.3, no changes required.
  * Add the libqt5opengl5-desktop-dev build dependency, as krita supports only
    Desktop OpenGL.

 -- Pino Toscano <pino@debian.org>  Sat, 13 Jan 2018 10:10:22 +0100

krita (1:3.3.2.1+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Update copyright.

 -- Pino Toscano <pino@debian.org>  Sat, 04 Nov 2017 07:57:38 +0100

krita (1:3.3.1+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Remove mentions of Calligra from descriptions. (Closes: #877631)
  * Update copyright.
  * Bump Standards-Version to 4.1.1, no changes required.

 -- Pino Toscano <pino@debian.org>  Wed, 11 Oct 2017 20:58:58 +0200

krita (1:3.3.0+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Drop all the pre-Jessie replaces/breaks.
  * Bump Standards-Version to 4.1.0, no changes required.

 -- Pino Toscano <pino@debian.org>  Thu, 28 Sep 2017 11:28:26 +0200
